import { IAuthProvider } from "./iauth-provider";
import { RequestOptions, TransactionPageResponse } from "./types";
import { SDKOptions } from "./fireblocks-sdk";
export declare class ApiClient {
    private authProvider;
    private apiBaseUrl;
    private options?;
    private axiosInstance;
    constructor(authProvider: IAuthProvider, apiBaseUrl: string, options?: SDKOptions);
    private getUserAgent;
    issueGetRequestForTransactionPages(path: string): Promise<TransactionPageResponse>;
    issueGetRequest<T>(path: string): Promise<T>;
    issuePostRequest<T>(path: string, body: any, requestOptions?: RequestOptions): Promise<T>;
    issuePutRequest<T>(path: string, body: any): Promise<T>;
    issuePatchRequest<T>(path: string, body: any): Promise<T>;
    issueDeleteRequest<T>(path: string): Promise<T>;
}
